(function ($, Drupal, CKEDITOR) {

  CKEDITOR.plugins.add('ckmoon', {
    icons: 'ckmoon',
    init: function (editor) {

      function insertContent(html) {
        var element = CKEDITOR.dom.element.createFromHtml(html);
        editor.insertElement( element );
      }

      function saveCallback(returnValue) {
        var prefix = '';

        if (typeof editor.config.ckmoon_prefix != 'undefined') {
          prefix = editor.config.ckmoon_prefix;
        }

        var cssClass = prefix + returnValue;

        var content = '<i class="' + cssClass + '">&thinsp;</i>';
        insertContent(content);
      }

      // Implementation before initializing plugin.
      editor.addCommand( 'addCkMoonIcon', {
        canUndo: true,
        exec: function (editor, data) {

          // Open dialog form.
          Drupal.ckeditor.openDialog(
            editor,
            Drupal.url('ckmoon/form/ckmoon_editor_dialog'),
            {},
            saveCallback,
            {}
          );
        }
      });

      editor.ui.addButton('CkMoon', {
        label: Drupal.t('CK Moon'),
        command: 'addCkMoonIcon'
      });
    },
  });
})(jQuery, Drupal, CKEDITOR);
